#Dependencies - Intalio system dependencies
#Copyright (C) 2019 by Драпевски Intalio

package Dependencies;

use Exporter qw( import );
our @EXPORT = qw( %NEEDED_MODULES );

use strict;

our %NEEDED_MODULES = (
    'ZI-INSTALLER' => [
        {
            Module   => 'JSON',
            Required => 1,
            Comment => 'Perl JSON (JavaScript Object Notation) encoder/decoder',
            InstTypes => {
                aptget => 'libjson-perl'
            }
        },
        {
            Module   => 'String::Random',
            Required => 1,
            Comment =>
              'Perl module to generate random strings based on a pattern',
            InstTypes => {
                aptget => 'libstring-random-perl'
            }
        },
        {
            Module   => 'Text::ASCIITable',
            Required => 1,
            Comment  => 'Create a nice formatted table using ASCII characters.',
            InstTypes => {
                aptget => 'libtext-asciitable-perl'
            }
        },
        {
            Module   => 'File::Copy::Recursive',
            Required => 1,
            Comment =>
              'Perl extension for recursively copying files and directories',
            InstTypes => {
                aptget => 'libfile-copy-recursive-perl'
            }
        },
        {
            Module     => 'Archive::Zip',
              Required => 1,
              Comment => 'Archive::Zip - Zip interface for Perl',
              InstTypes => { aptget => 'libarchive-zip-perl' }
        },
        {
            Module     => 'Archive::Zip::MemberRead',
              Required => 1,
              Comment => 'Archive::Zip::MemberRead - Read file from archive',
              InstTypes => { aptget => 'libarchive-zip-perl' }
        },
        {
            Module     => 'File::chmod',
            Required => 1,
            Comment => 'File::chmod - Recursive',
            InstTypes => { aptget => 'libfile-chmod-perl' }
        },
        {
            Module     => 'File::chmod::Recursive',
            Required => 1,
            Comment => 'File::chmod::Recursive - Recursive chmod',
            InstTypes => {  }
        }
    ],

    'ZI-LICENSEMANAGER' => [
        {
            Module   => 'JSON',
            Required => 1,
            Comment => 'Perl JSON (JavaScript Object Notation) encoder/decoder',
            InstTypes => {
                aptget => 'libjson-perl'
            }
        },
        {
            Module   => 'String::Random',
            Required => 1,
            Comment =>
              'Perl module to generate random strings based on a pattern',
            InstTypes => {
                aptget => 'libstring-random-perl'
            }
        },
        {
            Module   => 'Text::ASCIITable',
            Required => 1,
            Comment  => 'Create a nice formatted table using ASCII characters.',
            InstTypes => {
                aptget => 'libtext-asciitable-perl'
            }
        },
        {
            Module    => 'LWP::Authen::Basic',
            Required  => 1,
            Comment   => 'The World-Wide Web library for Perl',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        {
            Module    => 'LWP::Authen::Digest',
            Required  => 1,
            Comment   => 'The World-Wide Web library for Perl',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        {
            Module    => 'LWP::Protocol::cpan',
            Required  => 1,
            Comment   => 'Base class for LWP protocols',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        {
            Module    => 'LWP::Protocol::data',
            Required  => 1,
            Comment   => 'Base class for LWP protocols',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        {
            Module    => 'LWP::Protocol::file',
            Required  => 1,
            Comment   => 'Base class for LWP protocols',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        {
            Module    => 'LWP::Protocol::ftp',
            Required  => 1,
            Comment   => 'Base class for LWP protocols',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        {
            Module    => 'LWP::Protocol::gopher',
            Required  => 1,
            Comment   => 'Base class for LWP protocols',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        {
            Module    => 'LWP::Protocol::http',
            Required  => 1,
            Comment   => 'Base class for LWP protocols',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        {
            Module    => 'LWP::Protocol::https',
            Required  => 1,
            Comment   => 'Provide https support for LWP::UserAgent',
            InstTypes => {
                aptget => 'liblwp-protocol-https-perl'
            }
        },
        {
            Module    => 'LWP::Protocol::ldap',
            Required  => 1,
            Comment   => 'Provide LDAP support for LWP::UserAgent',
            InstTypes => {
                aptget => 'libnet-ldap-perl'
            }
        },
        {
            Module    => 'LWP::Protocol::ldaps',
            Required  => 1,
            Comment   => 'Provide LDAP support for LWP::UserAgent',
            InstTypes => {
                aptget => 'libnet-ldap-perl'
            }
        },
        {
            Module    => 'LWP::Protocol::loopback',
            Required  => 1,
            Comment   => 'Base class for LWP protocols',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        # {
        #     Module    => 'LWP::Protocol::mailto',
        #     Required  => 1,
        #     Comment   => 'Base class for LWP protocols',
        #     InstTypes => {
        #         aptget => 'libwww-perl'
        #     }
        # },
        {
            Module    => 'LWP::Protocol::nntp',
            Required  => 1,
            Comment   => 'Base class for LWP protocols',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        {
            Module    => 'LWP::Protocol::nogo',
            Required  => 1,
            Comment   => 'Base class for LWP protocols',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        {
            Module    => 'LWP::UserAgent',
            Required  => 1,
            Comment   => 'Base class for LWP protocols',
            InstTypes => {
                aptget => 'libwww-perl'
            }
        },
        {
            Module    => 'Term::ReadKey',
            Required  => 1,
            Comment   => 'A perl module for simple terminal control',
            InstTypes => {
                aptget => 'libterm-readkey-perl'
            }
        },
        {
            Module    => 'URI::URL',
            Required  => 1,
            Comment   => 'Uniform Resource Locators',
            InstTypes => {
                aptget => 'liburi-perl'
            }
        },
        {
            Module    => 'URI::http',
            Required  => 1,
            Comment   => 'Uniform Resource Locators',
            InstTypes => {
                aptget => 'liburi-perl'
            }
        },
        {
            Module   => 'File::Copy::Recursive',
            Required => 1,
            Comment =>
              'Perl extension for recursively copying files and directories',
            InstTypes => {
                aptget => 'libfile-copy-recursive-perl'
            }
        },
        {
            Module     => 'Try::Tiny',
              Required => 1,
              Comment => 'Try::Tiny - Minimal try/catch with proper preservation of $@',
              InstTypes => { aptget => 'libtry-tiny-perl' }
        },
        {
            Module     => 'Archive::Zip',
              Required => 1,
              Comment => 'Archive::Zip - Zip interface for Perl',
              InstTypes => { aptget => 'libarchive-zip-perl' }
        },
        {
            Module     => 'Archive::Zip::MemberRead',
              Required => 1,
              Comment => 'Archive::Zip::MemberRead - Read file from archive',
              InstTypes => { aptget => 'libarchive-zip-perl' }
        }
    ],

    'ZI-IMPORTEXPORT' => [
        {
            Module   => 'JSON',
            Required => 1,
            Comment => 'Perl JSON (JavaScript Object Notation) encoder/decoder',
            InstTypes => {
                aptget => 'libjson-perl'
            }
        },
        {
            Module   => 'File::Copy::Recursive',
            Required => 1,
            Comment =>
              'Perl extension for recursively copying files and directories',
            InstTypes => {
                aptget => 'libfile-copy-recursive-perl'
            }
        },
        {
            Module     => 'Archive::Zip',
              Required => 1,
              Comment => 'Archive::Zip - Zip interface for Perl',
              InstTypes => { aptget => 'libarchive-zip-perl' }
        },
        {
            Module     => 'Archive::Zip::MemberRead',
              Required => 1,
              Comment => 'Archive::Zip::MemberRead - Read file from archive',
              InstTypes => { aptget => 'libarchive-zip-perl' }
        }
      ]

);

1;
