﻿#Intalio::Input
#Copyright (C) 2019 by Драпевски Intalio, Release 1.00

package Intalio::Input;

use Exporter qw( import );
our @EXPORT = qw( PrintYesNoInput PrintSelectOptionInput );

use strict;

sub PrintYesNoInput {
    my ($Caption, $DefaultChoice, $CustomChoiceString) = @_;
    $DefaultChoice = ($DefaultChoice) ? uc $DefaultChoice : "Y";

    my $ChoiceString;
    if (defined $CustomChoiceString) {
        $ChoiceString = $CustomChoiceString;
    } else {
        if ($DefaultChoice eq "Y") {
            $ChoiceString = "(Y/n or exit)";
        } elsif ($DefaultChoice eq "N") {
            $ChoiceString = "(y/N or exit)";
        } elsif ($DefaultChoice eq "EXIT") {
            $ChoiceString = "(y/n or EXIT)";
        } else {
            $ChoiceString = "(Y/n or exit)";
        }
    }

    print("$Caption\n$ChoiceString: ");
    do {
        chomp(my $UserChoice = <STDIN>);
        $UserChoice = ($UserChoice eq "") ? $DefaultChoice : uc $UserChoice;
        if ($UserChoice eq "Y") {
            return 1;
        } elsif ($UserChoice eq "N") {
            return 0;
        } elsif ($UserChoice eq "EXIT") {
            exit(1);
        }
        print("Unknown command! Please try again...\n");
        print("$ChoiceString: ");
    } while (1);
}


sub PrintSelectOptionInput {
    my $Data = shift;

    die "Data is not ARRAY ref" if ref($Data) ne "ARRAY";
    return if @$Data < 1;

    my $Chose;
    my $ItemsCount = scalar @$Data;

    while (1) {
        if ($ItemsCount > 1) {
            print "Please choose from 1-$ItemsCount option or type exit\nYour option: ";
        } else {
            print "Please choose an option or type exit\nYour option: ";
        }

        chomp($Chose = <STDIN>);

        if ($Chose =~ /exit/i) {
            exit(1);
        }

       last if ($Chose >= 1 && $Chose <= $ItemsCount );

       print "Invalid option!\n";
    }

    return $Data->[$Chose - 1];
}


1;