#Intalio::Outpput
#Copyright (C) 2019 by Драпевски Intalio, Release 1.00

package Intalio::Output;

use Exporter qw( import );
our @EXPORT = qw(  PrintTable );

use strict;
use FindBin;
use lib "$FindBin::RealBin/../";

use Text::ASCIITable;

sub PrintTable {
    my $TableName = shift;
    my $Data = shift;
    my $OnlySpecyfiedColumns = shift || [];

    die "Data is not ARRAY ref" if ref($Data) ne "ARRAY";
   
    return '' if @$Data < 1;

    my @Columns;

    if (@$OnlySpecyfiedColumns == 0) {
        @Columns = keys %{$Data->[0]};
    } else {
        @Columns = @$OnlySpecyfiedColumns;
    }

    unshift @Columns, 'Nr';

    my $table = Text::ASCIITable->new({ headingText => $TableName });
    $table->setCols(@Columns);
    shift @Columns;

    my $Counter = 0;
     for my $row (@$Data) {
        my @temp_row = (++$Counter);
        for my $col (@Columns) {
            push @temp_row,  ref($row) eq 'HASH' ? $row->{$col} : $row;
        }

        $table->addRow(@temp_row);
    }

    $table->addRowLine();

    return $table;
}



1;